--Finding image
local files = love.filesystem.getDirectoryItems("")
local types = {".jpg", ".png"}
local image = false
for i,v in ipairs(files) do
	local f = false
	for _,b in ipairs(types) do
		local s, e = v:find(b)
		if s ~= nil then
			image = love.graphics.newImage(v)
			f = true
			break
		end
		if f then break end
	end
end

if image ~= false then
	local w = image:getWidth()
	local h = image:getHeight()
	local cw, ch, flags = love.window.getMode()
	love.window.setMode(w, h, flags)
else
	error("No image found, Put a .jpg or .png image in the same folder as main.lua") 
end

screen = {
		width = love.graphics.getWidth(),
		height = love.graphics.getHeight()
	}

local time = 0
local dist_size = 15
local dist_step = 1
	
function love.load()
	distortion:send("size", dist_size)
end

function love.update(dt)
	time = time + dt
	distortion:send("time", time)
end

function love.draw()

	love.graphics.setShader(distortion)
	love.graphics.draw(image)
	love.graphics.setShader()

	love.graphics.print("Distortion Size: "..dist_size, 12, 12)
end

function love.keypressed(key)
	if key == "escape" then love.event.push("quit") end
end

function love.mousepressed(x, y, key)
	local step = dist_step
	if love.keyboard.isDown("lshift") or love.keyboard.isDown("rshift") then
		step = dist_step * 10
	end
	if key == "wu" then
		dist_size = dist_size + step
	elseif key == "wd" then
		dist_size = dist_size - step
	end
	distortion:send("size", dist_size)
end

distortion = love.graphics.newShader([[
	extern number time;
	extern number size;
	vec4 effect(vec4 color, Image tex, vec2 tc, vec2 pc)
	{
		vec2 p = tc;
		p.x = p.x + sin(p.y * size + time) * 0.03;
		return Texel(tex, p);
	}
]])

